From 5692851a327709915386bb6f3ca6f46cd7de87e5 Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Thu, 1 Jul 2021 20:19:25 +0000
Subject: [PATCH] [arm64] port luma_vpp

luma_vpp[  8x8]		18.11x 	 111.65   	 2022.39
luma_vpp[16x16]		19.27x 	 421.50   	 8121.55
luma_vpp[32x32]		19.09x 	 1696.87  	 32397.44
luma_vpp[64x64]		19.21x 	 6736.58  	 129415.98
luma_vpp[  8x4]		17.57x 	 57.39    	 1008.53
luma_vpp[ 16x8]		19.14x 	 212.14   	 4060.71
luma_vpp[ 8x16]		18.30x 	 220.76   	 4041.03
luma_vpp[32x16]		19.17x 	 845.46   	 16208.95
luma_vpp[16x32]		19.10x 	 849.88   	 16228.74
luma_vpp[64x32]		19.18x 	 3372.42  	 64683.56
luma_vpp[32x64]		19.17x 	 3381.36  	 64805.89
luma_vpp[16x12]		19.15x 	 318.42   	 6098.15
luma_vpp[12x16]		14.57x 	 421.29   	 6136.53
luma_vpp[ 16x4]		18.82x 	 108.05   	 2033.59
luma_vpp[32x24]		19.05x 	 1275.70  	 24300.62
luma_vpp[24x32]		18.91x 	 1281.01  	 24225.15
luma_vpp[ 32x8]		19.16x 	 423.41   	 8111.60
luma_vpp[ 8x32]		18.64x 	 431.75   	 8049.92
luma_vpp[64x48]		19.21x 	 5052.34  	 97040.00
luma_vpp[48x64]		19.16x 	 5067.80  	 97103.17
luma_vpp[64x16]		19.23x 	 1682.66  	 32359.54
luma_vpp[16x64]		19.21x 	 1688.93  	 32438.52
---
 source/common/aarch64/asm-primitives.cpp |  22 +++
 source/common/aarch64/ipfilter8.S        | 215 +++++++++++++++++++++++
 source/common/aarch64/ipfilter8.h        |  22 +++
 3 files changed, 259 insertions(+)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index 76c9882..902b44f 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -245,6 +245,28 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.pu[LUMA_4x4].luma_vpp     = PFX(interp_8tap_vert_pp_4x4_neon);
         p.pu[LUMA_4x8].luma_vpp     = PFX(interp_8tap_vert_pp_4x8_neon);
         p.pu[LUMA_4x16].luma_vpp    = PFX(interp_8tap_vert_pp_4x16_neon);
+        p.pu[LUMA_8x4].luma_vpp     = PFX(interp_8tap_vert_pp_8x4_neon);
+        p.pu[LUMA_8x8].luma_vpp     = PFX(interp_8tap_vert_pp_8x8_neon);
+        p.pu[LUMA_8x16].luma_vpp    = PFX(interp_8tap_vert_pp_8x16_neon);
+        p.pu[LUMA_8x32].luma_vpp    = PFX(interp_8tap_vert_pp_8x32_neon);
+        p.pu[LUMA_16x4].luma_vpp    = PFX(interp_8tap_vert_pp_16x4_neon);
+        p.pu[LUMA_16x8].luma_vpp    = PFX(interp_8tap_vert_pp_16x8_neon);
+        p.pu[LUMA_16x16].luma_vpp   = PFX(interp_8tap_vert_pp_16x16_neon);
+        p.pu[LUMA_16x32].luma_vpp   = PFX(interp_8tap_vert_pp_16x32_neon);
+        p.pu[LUMA_16x64].luma_vpp   = PFX(interp_8tap_vert_pp_16x64_neon);
+        p.pu[LUMA_16x12].luma_vpp   = PFX(interp_8tap_vert_pp_16x12_neon);
+        p.pu[LUMA_32x8].luma_vpp    = PFX(interp_8tap_vert_pp_32x8_neon);
+        p.pu[LUMA_32x16].luma_vpp   = PFX(interp_8tap_vert_pp_32x16_neon);
+        p.pu[LUMA_32x32].luma_vpp   = PFX(interp_8tap_vert_pp_32x32_neon);
+        p.pu[LUMA_32x64].luma_vpp   = PFX(interp_8tap_vert_pp_32x64_neon);
+        p.pu[LUMA_32x24].luma_vpp   = PFX(interp_8tap_vert_pp_32x24_neon);
+        p.pu[LUMA_64x16].luma_vpp   = PFX(interp_8tap_vert_pp_64x16_neon);
+        p.pu[LUMA_64x32].luma_vpp   = PFX(interp_8tap_vert_pp_64x32_neon);
+        p.pu[LUMA_64x64].luma_vpp   = PFX(interp_8tap_vert_pp_64x64_neon);
+        p.pu[LUMA_64x48].luma_vpp   = PFX(interp_8tap_vert_pp_64x48_neon);
+        p.pu[LUMA_24x32].luma_vpp   = PFX(interp_8tap_vert_pp_24x32_neon);
+        p.pu[LUMA_48x64].luma_vpp   = PFX(interp_8tap_vert_pp_48x64_neon);
+        p.pu[LUMA_12x16].luma_vpp   = PFX(interp_8tap_vert_pp_12x16_neon);
     }
 }
 } // namespace X265_NS
diff --git a/source/common/aarch64/ipfilter8.S b/source/common/aarch64/ipfilter8.S
index 5d412f7..afd46f0 100644
--- a/source/common/aarch64/ipfilter8.S
+++ b/source/common/aarch64/ipfilter8.S
@@ -334,6 +334,16 @@ LUMA_VPP_4xN 4
 LUMA_VPP_4xN 8
 LUMA_VPP_4xN 16
 
+        // d0 -> v0
+        // d1 -> v4
+        // d2 -> v1
+        // d3 -> v5
+        // d4 -> v2
+        // d5 -> v6
+        // d6 -> v3
+        // d7 -> v7
+        // temp regs: v16, v19, v20, v21, v22, v23, v24.
+        // result in v17.4s, v18.4s
 .macro qpel_filter_0_32b
     movi            v24.8h, #64
     uxtl            v19.8h, v5.8b
@@ -470,8 +480,213 @@ LUMA_VPP_4xN 16
     add             v18.4s, v18.4s, v22.4s
 .endm
 
+.macro FILTER_VPP a b filterv
 
+.loop_\filterv\()_\a\()x\b:
 
+    mov             x7, x2
+    mov             x6, x0
+    eor             x9, x9, x9
+
+.loop_w8_\filterv\()_\a\()x\b:
+
+    add             x6, x0, x9
+
+    ld1             {v0.8b}, [x6], x1
+    ld1             {v4.8b}, [x6], x1
+    ld1             {v1.8b}, [x6], x1
+    ld1             {v5.8b}, [x6], x1
+    ld1             {v2.8b}, [x6], x1
+    ld1             {v6.8b}, [x6], x1
+    ld1             {v3.8b}, [x6], x1
+    ld1             {v7.8b}, [x6], x1
+
+    eor         v17.16b, v17.16b, v17.16b
+    eor         v18.16b, v18.16b, v18.16b
+
+   \filterv
+
+    mov             w12, #32
+    dup             v16.4s, w12
+    add             v17.4s, v17.4s, v16.4s
+    sqshrun         v0.8b, v17.8h, #6
+    add             v18.4s, v18.4s, v16.4s
+    sqshrun         v1.8b, v18.8h, #6
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    st1             {v0.8b}, [x7], #8
+
+    add             x9, x9, #8
+    cmp             x9, #\a
+    blt             .loop_w8_\filterv\()_\a\()x\b
+
+    add             x0, x0, x1
+    add             x2, x2, x3
+    sub             x5, x5, #1
+    cbnz            x5, .loop_\filterv\()_\a\()x\b
+
+.endm
+
+// void interp_vert_pp_c(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx)
+.macro LUMA_VPP  w h
+function x265_interp_8tap_vert_pp_\w\()x\h\()_neon
+
+    lsl             x5, x1, #2
+    sub             x5, x5, x1
+    sub             x0, x0, x5      // src -= (8 / 2 - 1) * srcStride
+    mov             x5, #\h
+
+    cmp             x4, #0
+    b.eq            0f
+    cmp             x4, #1
+    b.eq            1f
+    cmp             x4, #2
+    b.eq            2f
+    cmp             x4, #3
+    b.eq            3f
+0:
+    FILTER_VPP  \w \h qpel_filter_0_32b
+    ret
+1:
+    FILTER_VPP  \w \h qpel_filter_1_32b
+    ret
+2:
+    FILTER_VPP  \w \h qpel_filter_2_32b
+    ret
+3:
+    FILTER_VPP  \w \h qpel_filter_3_32b
+    ret
+endfunc
+.endm
+
+LUMA_VPP 8 4
+LUMA_VPP 8 8
+LUMA_VPP 8 16
+LUMA_VPP 8 32
+LUMA_VPP 16 4
+LUMA_VPP 16 8
+LUMA_VPP 16 16
+LUMA_VPP 16 32
+LUMA_VPP 16 64
+LUMA_VPP 16 12
+LUMA_VPP 32 8
+LUMA_VPP 32 16
+LUMA_VPP 32 32
+LUMA_VPP 32 64
+LUMA_VPP 32 24
+LUMA_VPP 64 16
+LUMA_VPP 64 32
+LUMA_VPP 64 64
+LUMA_VPP 64 48
+LUMA_VPP 24 32
+LUMA_VPP 48 64
+
+function x265_interp_8tap_vert_pp_12x16_neon
+    lsl             x5, x1, #2
+    sub             x5, x5, x1
+    sub             x0, x0, x5      // src -= (8 / 2 - 1) * srcStride
+
+    mov             x5, #16
+.loop_vpp_12x16:
+
+    mov             x6, x0
+    mov             x7, x2
+
+    ld1             {v0.8b}, [x6], x1
+    ld1             {v4.8b}, [x6], x1
+    ld1             {v1.8b}, [x6], x1
+    ld1             {v5.8b}, [x6], x1
+    ld1             {v2.8b}, [x6], x1
+    ld1             {v6.8b}, [x6], x1
+    ld1             {v3.8b}, [x6], x1
+    ld1             {v7.8b}, [x6], x1
+
+    eor         v17.16b, v17.16b, v17.16b
+    eor         v18.16b, v18.16b, v18.16b
+
+    cmp             x4, #0
+    b.eq            0f
+    cmp             x4, #1
+    b.eq            1f
+    cmp             x4, #2
+    b.eq            2f
+    cmp             x4, #3
+    b.eq            3f
+0:
+    qpel_filter_0_32b
+    b            5f
+1:
+    qpel_filter_1_32b
+    b            5f
+2:
+    qpel_filter_2_32b
+    b            5f
+3:
+    qpel_filter_3_32b
+    b            5f
+5:
+    mov             w12, #32
+    dup             v16.4s, w12
+    add             v17.4s, v17.4s, v16.4s
+    sqshrun         v0.8b, v17.8h, #6
+    add             v18.4s, v18.4s, v16.4s
+    sqshrun         v1.8b, v18.8h, #6
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    st1             {v0.8b}, [x7], #8
+
+    add             x6, x0, #8
+
+    ld1             {v0.8b}, [x6], x1
+    ld1             {v4.8b}, [x6], x1
+    ld1             {v1.8b}, [x6], x1
+    ld1             {v5.8b}, [x6], x1
+    ld1             {v2.8b}, [x6], x1
+    ld1             {v6.8b}, [x6], x1
+    ld1             {v3.8b}, [x6], x1
+    ld1             {v7.8b}, [x6], x1
+
+    eor         v17.16b, v17.16b, v17.16b
+    eor         v18.16b, v18.16b, v18.16b
+
+    cmp             x4, #0
+    b.eq            0f
+    cmp             x4, #1
+    b.eq            1f
+    cmp             x4, #2
+    b.eq            2f
+    cmp             x4, #3
+    b.eq            3f
+0:
+    qpel_filter_0_32b
+    b            5f
+1:
+    qpel_filter_1_32b
+    b            5f
+2:
+    qpel_filter_2_32b
+    b            5f
+3:
+    qpel_filter_3_32b
+    b            5f
+5:
+    mov             w12, #32
+    dup             v16.4s, w12
+    add             v17.4s, v17.4s, v16.4s
+    sqshrun         v0.8b, v17.8h, #6
+    add             v18.4s, v18.4s, v16.4s
+    sqshrun         v1.8b, v18.8h, #6
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    fmov            w6, s0
+    str             w6, [x7], #4
+
+    add             x0, x0, x1
+    add             x2, x2, x3
+    sub             x5, x5, #1
+    cbnz            x5, .loop_vpp_12x16
+    ret
+endfunc
 
 .macro vextin8
     ld1             {v3.16b}, [x11], #16
diff --git a/source/common/aarch64/ipfilter8.h b/source/common/aarch64/ipfilter8.h
index f3324ec..fd724aa 100644
--- a/source/common/aarch64/ipfilter8.h
+++ b/source/common/aarch64/ipfilter8.h
@@ -53,6 +53,28 @@ void x265_filterPixelToShort_64x64_neon(const pixel* src, intptr_t srcStride, in
 void x265_interp_8tap_vert_pp_4x4_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
 void x265_interp_8tap_vert_pp_4x8_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
 void x265_interp_8tap_vert_pp_4x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_8x4_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_8x8_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_8x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_8x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_16x4_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_16x8_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_16x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_16x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_16x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_16x12_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_32x8_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_32x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_32x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_32x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_32x24_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_64x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_64x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_64x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_64x48_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_24x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_48x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_pp_12x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
 
 void x265_interp_8tap_horiz_ps_4x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
 void x265_interp_8tap_horiz_ps_4x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-- 
2.25.1

